--Load font
text = pge.font.load("Fonts/text.ttf", 8, PGE_RAM);
text2 = pge.font.load("Fonts/text.ttf", 11, PGE_RAM);
ingame = pge.font.load("Fonts/text.ttf", 15, PGE_RAM);
loaded = false; 
--Create colors:
white = pge.gfx.createcolor(255, 255, 255, 255);
green = pge.gfx.createcolor(30, 220, 30, 200);
black = pge.gfx.createcolor(0, 0, 0, 200);
black2 = pge.gfx.createcolor(0, 0, 0, 255);
blackreload = pge.gfx.createcolor(0, 0, 0, 100);
loading = pge.texture.load("gfx/loading.png", PGE_RAM);
local counter = 0;
local x = 0;
local xtimer = 0;
function loadEverything()
 ---Load Images/Sounds/Font
 if not loaded then
  --load images
  ammoshot = pge.texture.load("gfx/ammo.png", PGE_RAM);
  base = pge.texture.load("gfx/base.png", PGE_RAM);
  tower = pge.texture.load("gfx/tower.png", PGE_RAM);
  tower_shoot = pge.texture.load("gfx/shoot.png", PGE_RAM);
  ingamebar = pge.texture.load("gfx/ingamebar.png", PGE_RAM);
  shot = pge.texture.load("gfx/shot.png", PGE_RAM);
  cursor = pge.texture.load("gfx/aimpoint.png", PGE_RAM);
  explosion_mg1 = pge.texture.load("gfx/explosion_mg1.png", PGE_RAM);
  explosion_mg2 = pge.texture.load("gfx/explosion_mg2.png", PGE_RAM);
  explosion_mg3 = pge.texture.load("gfx/explosion_mg3.png", PGE_RAM);
  explosion_mg4 = pge.texture.load("gfx/explosion_mg4.png", PGE_RAM);
  ship1 = pge.texture.load("gfx/small_green.png", PGE_RAM);
  ship2 = pge.texture.load("gfx/rund_green.png", PGE_RAM);
  ship3 = pge.texture.load("gfx/small_yellow.png", PGE_RAM);
  ship4 = pge.texture.load("gfx/silber.png", PGE_RAM);
  ship5 = pge.texture.load("gfx/small_green2.png", PGE_RAM);
  ship6 = pge.texture.load("gfx/small_silver.png", PGE_RAM);
  ship_big = pge.texture.load("gfx/big.png", PGE_RAM);
  explosion_ship1 = pge.texture.load("gfx/explosion_ship4.png", PGE_RAM);
  explosion_ship2 = pge.texture.load("gfx/explosion_ship3.png", PGE_RAM);
  explosion_ship3 = pge.texture.load("gfx/explosion_ship2.png", PGE_RAM);
  explosion_ship4 = pge.texture.load("gfx/explosion_ship1.png", PGE_RAM);
  ingamebox = pge.texture.load("gfx/box.png", PGE_RAM);
  bgmenu = pge.texture.load("gfx/background.png", PGE_RAM);
  kasten = pge.texture.load("gfx/kasten.png", PGE_RAM);
  kasten2 = pge.texture.load("gfx/kasten2.png", PGE_RAM);
  bg1 = pge.texture.load("gfx/bg1.png", PGE_RAM);
  bg2 = pge.texture.load("gfx/bg2.png", PGE_RAM);
  bg = bg1;
  extra_planei = pge.texture.load("gfx/plane.png", PGE_RAM);
  extra_plane_shot = pge.texture.load("gfx/shot_plane.png", PGE_RAM);
  extra_plane_explosion = pge.texture.load("gfx/plane_explosion.png", PGE_RAM);
  extra_flugkoerperi = pge.texture.load("gfx/flugkoerper.png", PGE_RAM);
  extra_selecti = pge.texture.load("gfx/extra_select.png", PGE_RAM);
  bombi = pge.texture.load("gfx/bomb.png", PGE_RAM);
  bgmissions1 = pge.texture.load("gfx/kampange_1.png", PGE_RAM);
  schloss = pge.texture.load("gfx/schloss.png", PGE_RAM);
  star = pge.texture.load("gfx/star.png", PGE_RAM);
  victory = pge.texture.load("gfx/victory.png", PGE_RAM);
  icon_1 = pge.texture.load("gfx/icon_1.png", PGE_RAM);
  icon_2 = pge.texture.load("gfx/icon_2.png", PGE_RAM);
  icon_3 = pge.texture.load("gfx/icon_3.png", PGE_RAM);
  icon_4 = pge.texture.load("gfx/icon_4.png", PGE_RAM);
  icon_5 = pge.texture.load("gfx/icon_5.png", PGE_RAM);
  icon_6 = pge.texture.load("gfx/icon_6.png", PGE_RAM);
  icon_7 = pge.texture.load("gfx/icon_7.png", PGE_RAM);
  icon_8 = pge.texture.load("gfx/icon_8.png", PGE_RAM);
  icon_9 = pge.texture.load("gfx/icon_9.png", PGE_RAM);
  spuri = pge.texture.load("gfx/spur.png", PGE_RAM);
  --embleme:
  emblem = {};
  for i = 1, 20 do
  emblem[i] = pge.texture.load("gfx/rank/" .. i .. "_pic.png", PGE_RAM); 
  end
  closed = pge.texture.load("gfx/challenge/closed.png", PGE_RAM)
  --set variables tower
  cursor_x = 100;
  cursor_y = 100;
  tower_angle = 0;
  bullet = {};
  bulletspeed = 1
  shoottimer = 0;
  reloadtimer = 0;
  shots = 0;
  writetopoints = true;
  tower_life = 10;
  tower_explosiontimer = 0;
  tower_gamma = 255;
  tower_stat = "normal";
  --set variables ships:
  ballons = 0;
  ballon = {};
  wave = 0;
  waves_to_beat = 0;
  ballons_to_kill = 0;
  ballons_that_come = 0;
  ballonsperwave = 10;
  ballontimer = 0;
  ballontimermax = 300;
  drawroundtimer = 0;
  endroundtimer = 0;
  points = 0;
  endgegner = 0;
  bombs = 0;
  bomb = {}
  --set variables menu:
  menucounter = 1;
  upgradepoints = 0;
  dofile("game/points.txt");
  upgrade_select = 1;
  level = 1;
  newpoints = 2;
  --set variables extras:
  extra_guns = false;
  extra_plane = false;
  extra_explane = false;
  reload_guns = 0;
  reload_plane = 0;
  reload_explane = 0;
  extra_select = 1;
  planes = 0;
  plane = {};
  flugkoerpers = 0;
  flugkoerper = {};
  pointsminus_shots = 0;
  pointsminus_plane = 0;
  pointsminus_explane = 0;
  --set variables missions:
  select_mission = 1;
  free_missions = 1;
  missions_x = 0;
  --vars for stat:
  shots_shooted = 0;
  ballons_shooted = 0;
  hit = 0;
  bombs_dropped = 0;
  airstrikes = 0;
  planes_wanted = 0;
  explanes_wanted = 0;
  totalpointsget = 0;
  --load functions
  dofile("game/functions.lua");
  dofile("game/setmissions.lua");
  dofile("game/level.txt");
  dofile("game/cfg.txt");
  ammo = maxshots;
  endgametimer = 0;
  toturial = true;
  toturial_timer = 0;
  toturial_gamma = 255;
  toturialgame = true;
  toturial_timer_game = 0;
  toturial_gamma_game = 255;
  menu_gamma = 0;
  menu_x = 0;
  --load sounds:
  snd_plane = pge.wav.load("sfx/plane.wav");
  snd_explane = pge.wav.load("sfx/explane.wav");
  snd_explosion = pge.wav.load("sfx/explosion.wav");
  snd_points = pge.wav.load("sfx/points.wav");
    --vars for bullet spuren:
  spur = {};
  ispur = 0;
  spurtimer = 0;
  loaded = true;
 end
end

function writebackup()
--write to file:
 cfgfile = io.open("game/backup.txt", "w");
 cfgfile:write("genauigkeit = "..genauigkeit.."\n");
 cfgfile:write("plusbulletspeed = "..plusbulletspeed.."\n");
 cfgfile:write("demage_min = "..demage_min.."\n");
 cfgfile:write("demage_max = "..demage_max.."\n");
 cfgfile:write("shoottimermax = "..shoottimermax.."\n");
 cfgfile:write("reloadtimermax = "..reloadtimermax.."\n");
 cfgfile:write("maxshots = "..maxshots.."\n");
 cfgfile:write("upgradepoints = "..upgradepoints.."\n");
 cfgfile:write("reload_gunsmax = "..reload_gunsmax.."\n");
 cfgfile:write("reload_planemax = "..reload_planemax.."\n");
 cfgfile:write("reload_explanemax = "..reload_explanemax.."\n");
 cfgfile:write("level = "..level.."\n");
 cfgfile:write("newpoints = "..newpoints.."\n");
 cfgfile:write("totalpoints = "..totalpoints.."\n");
 cfgfile:write("free_missions = "..free_missions.."\n");
 cfgfile:write("--Backup file of Ballon Invasion. Please do NOT change any variables. your game might break down ..." .. "\n");
 cfgfile:close();
 end
    intro = pge.texture.load("gfx/intro.png", PGE_RAM)
introtimer = 0;
introgamma = 0;
while pge.running() do
 pge.controls.update();
 pge.gfx.startdrawing();
 if  counter < 250 then
 pge.gfx.clearscreen(white);
 else pge.gfx.clearscreen();
 end
 
 text:activate();
 if loaded then
 if counter < 250 then
  loading:activate();
  loading:draweasy(0,0,0,255);
  end
  ingame:activate();
  if counter < 50 then
  ingame:print(130,225,black,"Loading Complete")
  end
  counter = counter + 1;
  if counter >= 50 and counter < 250 then
  ingame:activate();
  ingame:print(2,110,black,"JamesCutter")
  ingame:print(210,15,black,"und")
  ingame:print(325,110,black,"TH3_H!TCH3R")
  end
  if counter >= 100 and counter < 250 then
  ingame:print(150,225,black,"praesentieren:")
  end
  if counter >= 250 and counter < 600 then
   bgmenu:activate();
   bgmenu:draweasy(0,0,0,x);
   if x < 255 and counter < 350 then x = x + 15; end
   if xtimer <= 5 and counter > 350 then x = x + 15; end
   if xtimer >= 6 and counter > 350 then x = x - 15; end
   if xtimer >= 11 and counter > 350 then xtimer = 0 end
   xtimer = xtimer + 1
  end
  if counter >= 600 then
   pge.gfx.clearscreen();
  end
   if counter >= 800 then
	intro:activate();
	intro:draweasy(0,0,0,introgamma)
	if introtimer == 0 then
		introgamma = introgamma + 2;
		if introgamma >= 255 then
		introtimer = 1;
		writebackup();
		end
	end
	if introtimer == 1 then
		introgamma = introgamma - 2;
		if introgamma <= 0 then
			dofile("game/menu.lua")
		end
	end
  end
 end
 
 if not loaded then
  loading:activate();
  loading:draweasy(0,0,0,255);
  ingame:activate();
  ingame:print(130,225,black,"Loading")
  counter = counter + 1;
  
  if counter > 50 then
   counter = 0;
   --Load Everything
   loadEverything();
  end
 end
 
 pge.gfx.enddrawing();
 pge.gfx.swapbuffers();
end
